<?php
/*
Plugin Name: Payriff Opencart 3.x Payment Gateway
Plugin URI: https://payriff.az/
Version: 1.0.0
Author: GlobalSoft
Author URI: https://globalsoft.az/
*/


class ControllerExtensionPaymentPayriff extends Controller {

    private $error = array();



    public function index() {

        $this->load->language('extension/payment/payriff');



        $this->document->setTitle($this->language->get('heading_title'));



        $this->load->model('setting/setting');



        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

            

            if(!$this->config->get('payment_payriff_url')) {

                $this->load->model('extension/payment/payriff');

		        $this->model_extension_payment_payriff->generateTable();

            }

            

            $this->model_setting_setting->editSetting('payment_payriff', $this->request->post);



            $this->session->data['success'] = $this->language->get('text_success');



            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));

        }



        if (isset($this->error['warning'])) {

            $data['error_warning'] = $this->error['warning'];

        } else {

            $data['error_warning'] = '';

        }



        if (isset($this->error['url'])) {

            $data['error_url'] = $this->error['url'];

        } else {

            $data['error_url'] = '';

        }



        if (isset($this->error['merchant'])) {

            $data['error_merchant'] = $this->error['merchant'];

        } else {

            $data['error_merchant'] = '';

        }



        if (isset($this->error['security'])) {

            $data['error_security'] = $this->error['security'];

        } else {

            $data['error_security'] = '';

        }



        if (isset($this->error['currency'])) {

            $data['error_currency'] = $this->error['currency'];

        } else {

            $data['error_currency'] = '';

        }



        $data['breadcrumbs'] = array();



        $data['breadcrumbs'][] = array(

            'text' => $this->language->get('text_home'),

            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)

        );



        $data['breadcrumbs'][] = array(

            'text' => $this->language->get('text_extension'),

            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)

        );



        $data['breadcrumbs'][] = array(

            'text' => $this->language->get('heading_title'),

            'href' => $this->url->link('extension/payment/payriff', 'user_token=' . $this->session->data['user_token'], true)

        );



        $data['action'] = $this->url->link('extension/payment/payriff', 'user_token=' . $this->session->data['user_token'], true);



        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);



        if (isset($this->request->post['payment_payriff_url'])) {

            $data['payment_payriff_url'] = $this->request->post['payment_payriff_url'];

        } elseif(!empty($this->config->get('payment_payriff_url'))) {

            $data['payment_payriff_url'] = $this->config->get('payment_payriff_url');

        } else {

            $data['payment_payriff_url'] = "https://api.payriff.com/api/v1/";

        }



        if (isset($this->request->post['payment_payriff_merchant'])) {

            $data['payment_payriff_merchant'] = $this->request->post['payment_payriff_merchant'];

        } else {

            $data['payment_payriff_merchant'] = $this->config->get('payment_payriff_merchant');

        }



        if (isset($this->request->post['payment_payriff_security'])) {

            $data['payment_payriff_security'] = $this->request->post['payment_payriff_security'];

        } else {

            $data['payment_payriff_security'] = $this->config->get('payment_payriff_security');

        }



        $data['callback'] = HTTP_CATALOG . 'index.php?route=extension/payment/payriff/callback';



        if (isset($this->request->post['payment_payriff_total'])) {

            $data['payment_payriff_total'] = $this->request->post['payment_payriff_total'];

        } else {

            $data['payment_payriff_total'] = $this->config->get('payment_payriff_total');

        }



        if (isset($this->request->post['payment_payriff_currency'])) {

            $data['payment_payriff_currency'] = $this->request->post['payment_payriff_currency'];

        } else {

            $data['payment_payriff_currency'] = $this->config->get('payment_payriff_currency');

        }



        if (isset($this->request->post['payment_payriff_order_status_id'])) {

            $data['payment_payriff_order_status_id'] = $this->request->post['payment_payriff_order_status_id'];

        } else {

            $data['payment_payriff_order_status_id'] = $this->config->get('payment_payriff_order_status_id');

        }



        $this->load->model('localisation/order_status');



        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();



        if (isset($this->request->post['payment_payriff_geo_zone_id'])) {

            $data['payment_payriff_geo_zone_id'] = $this->request->post['payment_payriff_geo_zone_id'];

        } else {

            $data['payment_payriff_geo_zone_id'] = $this->config->get('payment_payriff_geo_zone_id');

        }



        $this->load->model('localisation/geo_zone');



        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();



        if (isset($this->request->post['payment_payriff_status'])) {

            $data['payment_payriff_status'] = $this->request->post['payment_payriff_status'];

        } else {

            $data['payment_payriff_status'] = $this->config->get('payment_payriff_status');

        }



        if (isset($this->request->post['payment_payriff_sort_order'])) {

            $data['payment_payriff_sort_order'] = $this->request->post['payment_payriff_sort_order'];

        } else {

            $data['payment_payriff_sort_order'] = $this->config->get('payment_payriff_sort_order');

        }



        $data['header'] = $this->load->controller('common/header');

        $data['column_left'] = $this->load->controller('common/column_left');

        $data['footer'] = $this->load->controller('common/footer');



        $this->response->setOutput($this->load->view('extension/payment/payriff', $data));

    }



    protected function validate() {

        if (!$this->user->hasPermission('modify', 'extension/payment/payriff')) {

            $this->error['warning'] = $this->language->get('error_permission');

        }



        if (!$this->request->post['payment_payriff_url']) {

            $this->error['merchant'] = $this->language->get('error_url');

        }



        if (!$this->request->post['payment_payriff_merchant']) {

            $this->error['merchant'] = $this->language->get('error_merchant');

        }



        if (!$this->request->post['payment_payriff_security']) {

            $this->error['security'] = $this->language->get('error_security');

        }



        if (!$this->request->post['payment_payriff_currency']) {

            $this->error['currency'] = $this->language->get('error_currency');

        }



        return !$this->error;

    }

}