<?php



class ControllerExtensionPaymentPayriff extends Controller {



    private $encryptionToken;



    public function index() {



        $data['button_confirm'] = $this->language->get('button_confirm');



        $this->load->model('checkout/order');



        if(!isset($this->session->data['order_id'])) {

            return false;

        }



        return $this->load->view('extension/payment/payriff', $data);

    }



    public function confirm() {



        $json = [];



        if (isset($this->session->data['payment_method']['code']) && $this->session->data['payment_method']['code'] == 'payriff') {

            

            //Set Default Order Status

            $this->load->model('checkout/order');

            $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('config_order_status_id'));

            



            $this->encryptionToken = $this->encryptionToken();

            $request = $this->createOrderRequest();

            

            $response = $this->request('createOrder', $request);

            $result = json_decode($response['content']);



            $json['redirect'] = $result->payload->paymentUrl;

            

            //Insert Log Payriff OrderId and SessionId

            $this->load->model('extension/payment/payriff');

            $this->model_extension_payment_payriff->insertLog($this->session->data['order_id'], $result->payload);

            



        }



        $this->response->addHeader('Content-Type: application/json');

        $this->response->setOutput(json_encode($json));

    }



    public function callback()

    {

        if($this->request->server['REQUEST_METHOD'] == 'POST') {



            $rawData = file_get_contents("php://input");

            $json = json_decode($rawData);



            if($json->payload->orderStatus == 'APPROVED' && $json->code == '00000') {

                $this->load->model('checkout/order');

                $this->model_checkout_order->addOrderHistory($json->payload->orderDescription, $this->config->get('payment_payriff_order_status_id'));

            }

        } else {

            $this->encryptionToken = $this->encryptionToken();

            

            

            //Get Log Payriff OrderId and SessionId

            $this->load->model('extension/payment/payriff');

            $payment_detail = $this->model_extension_payment_payriff->getLog($this->request->get['order_id']);

            

            $request = $this->getOrderInformationRequest($payment_detail);

            

            

            $response = $this->request('getOrderInformation', $request);

            

            $result = json_decode($response['content']);

            

            if($result->payload->row->orderstatus == 'APPROVED' && $result->code == '00000') {

                $this->response->redirect($this->url->link('checkout/success', '', true));

            } else {

                $this->response->redirect($this->url->link('checkout/failure'));

            }

        }



    }



    protected function encryptionToken()

    {

        return time() . rand();

    }



    protected function authorization()

    {

        return $this->config->get('payment_payriff_security');

    }



    protected function createOrderRequest()

    {

        $this->load->model('checkout/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        

        $request = [

            'body'  => [

                "amount"        => $this->currency->convert($order_info['total'], $this->config->get('payment_payriff_currency'), $order_info['currency_code']),

                "approveURL"    => str_replace('&amp;', '&', $this->url->link('extension/payment/payriff/callback', 'order_id='.$this->session->data['order_id'], true)),

                "cancelURL"     => str_replace('&amp;', '&', $this->url->link('extension/payment/payriff/callback', 'order_id='.$this->session->data['order_id'], true)),

                "currencyType"  => $this->config->get('payment_payriff_currency'),

                "declineURL"    => str_replace('&amp;', '&', $this->url->link('extension/payment/payriff/callback', 'order_id='.$this->session->data['order_id'], true)),

                "description"   => $this->session->data['order_id'],

                "language"      => "AZ"

            ],

            "encryptionToken"   => $this->encryptionToken,

            "merchant"          => $this->config->get('payment_payriff_merchant')

        ];

        

        



        return json_encode($request);

    }



    protected function getOrderInformationRequest($payment_detail)

    {

        $request = [

            'body'  => [

                "language"          => "AZ",

                "orderId"           => $payment_detail['orderID'],

                "sessionId"         => $payment_detail['sessionID']

            ],

            "encryptionToken"   => $this->encryptionToken,

            "merchant"          => $this->config->get('payment_payriff_merchant')

        ];



        return json_encode($request);

    }









    protected function request($method = 'createOrder', $request = false) {

        $options = [

            CURLOPT_RETURNTRANSFER => true,

            CURLOPT_HEADER         => false,

            CURLOPT_FOLLOWLOCATION => true,

            CURLOPT_ENCODING       => "",

            CURLOPT_AUTOREFERER    => true,

            CURLOPT_CONNECTTIMEOUT => 120,

            CURLOPT_TIMEOUT        => 120,

            CURLOPT_MAXREDIRS      => 10,

            CURLOPT_POST           => true,

            CURLOPT_POSTFIELDS     => $request,

            CURLOPT_SSL_VERIFYPEER => false,

            CURLOPT_SSL_VERIFYHOST => false,

            CURLOPT_HTTPHEADER     => [

                'Authorization: '. $this->authorization(),

                'Content-type: application/json'

            ],

        ];



        $ch      = curl_init( $this->config->get('payment_payriff_url').$method );

        curl_setopt_array( $ch, $options );

        $content = curl_exec( $ch );

        $err     = curl_errno( $ch );

        $errmsg  = curl_error( $ch );

        $header  = curl_getinfo( $ch );

        curl_close( $ch );

        $header['errno']   = $err;

        $header['errmsg']  = $errmsg;

        $header['content'] = $content;



        return $header;

    }

}